using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.IO;

namespace WellFormedChecker
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmWellFormedChecker : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtBoxURI;
		private System.Windows.Forms.TextBox txtBoxCode;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnClear;
		private System.Windows.Forms.Button btnCheck;
		private System.Windows.Forms.Button btnSelect;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmWellFormedChecker()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtBoxURI = new System.Windows.Forms.TextBox();
			this.txtBoxCode = new System.Windows.Forms.TextBox();
			this.btnClose = new System.Windows.Forms.Button();
			this.btnClear = new System.Windows.Forms.Button();
			this.btnCheck = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtBoxURI
			// 
			this.txtBoxURI.Location = new System.Drawing.Point(16, 16);
			this.txtBoxURI.Name = "txtBoxURI";
			this.txtBoxURI.Size = new System.Drawing.Size(240, 20);
			this.txtBoxURI.TabIndex = 0;
			this.txtBoxURI.Text = "";
			// 
			// txtBoxCode
			// 
			this.txtBoxCode.Location = new System.Drawing.Point(16, 56);
			this.txtBoxCode.Multiline = true;
			this.txtBoxCode.Name = "txtBoxCode";
			this.txtBoxCode.Size = new System.Drawing.Size(232, 112);
			this.txtBoxCode.TabIndex = 1;
			this.txtBoxCode.Text = "<place some code here>";
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(272, 144);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 2;
			this.btnClose.Text = "Clos&e";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnClear
			// 
			this.btnClear.Location = new System.Drawing.Point(272, 96);
			this.btnClear.Name = "btnClear";
			this.btnClear.TabIndex = 3;
			this.btnClear.Text = "Clear &All";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// btnCheck
			// 
			this.btnCheck.Location = new System.Drawing.Point(272, 64);
			this.btnCheck.Name = "btnCheck";
			this.btnCheck.TabIndex = 4;
			this.btnCheck.Text = "&Check";
			this.btnCheck.Click += new System.EventHandler(this.btnCheck_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(272, 16);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.TabIndex = 5;
			this.btnSelect.Text = "&Select File";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// frmWellFormedChecker
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 190);
			this.Controls.Add(this.btnSelect);
			this.Controls.Add(this.btnCheck);
			this.Controls.Add(this.btnClear);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.txtBoxCode);
			this.Controls.Add(this.txtBoxURI);
			this.Name = "frmWellFormedChecker";
			this.Text = "Xml Well-Formed Checker";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmWellFormedChecker());
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnClear_Click(object sender, System.EventArgs e)
		{
			this.txtBoxCode.Text = "";
			this.txtBoxURI.Text = "";
			this.Refresh();
		}

		private void btnCheck_Click(object sender, System.EventArgs e)
		{
			//Get text from txtBoxes
			string strFileUri = this.txtBoxURI.Text;
			strFileUri = strFileUri.Trim();

			string strFileContent = this.txtBoxCode.Text;
			strFileContent = strFileContent.Trim();

			//Check is something interesting is filled in
			if (strFileUri != "" || strFileContent != "")
			{
				//Check which thing should be used, prefer strFileUri
				if (strFileUri != "")
				{
					//Get filename and check existence
					//Check for presence of lokal file
					if (File.Exists(strFileUri))
					{							
						//Construct XmlTextreader
						XmlTextReader read = new XmlTextReader(strFileUri);
						
						//Check reader
						string strResult = this.CheckWellFormedNess(read);
					
						//Close readers
						read.Close();
						
						MessageBox.Show(strResult, "Xml Well-Formed Check", System.Windows.Forms.MessageBoxButtons.OK, 
							System.Windows.Forms.MessageBoxIcon.Exclamation);					
					}
				}
				else if (strFileContent != "" &&  strFileContent != "<place some code here>")
				{
					//Construct string reader
					StringReader readString = new StringReader(strFileContent);
					
					//Construct XmlTextReader
					XmlTextReader read = new XmlTextReader(readString);

					//Check reader
					string strResult = this.CheckWellFormedNess(read);
					
					//Close readers
					read.Close();
					readString.Close();

					MessageBox.Show(strResult, "Xml Well-Formed Check", System.Windows.Forms.MessageBoxButtons.OK, 
								System.Windows.Forms.MessageBoxIcon.Exclamation);					
				}
			}
			else
			{
				//do nothing
			}
		}

		private void btnSelect_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.Filter = "All Xml type files (*.xbrl,*.xml,*.xsd)|*.xbrl;*.xml;*.xsd|Xbrl files (*.xbrl, *.xml)|*.xbrl;*.xml|Xml files (*.xml)|*.xml|Xsd files (*.xsd)|*.xsd|All files (*.*)|*.*";

			if (dlg.ShowDialog() == DialogResult.OK) 
			{
				this.txtBoxURI.Text = dlg.FileName.Trim();		  
			}
		}

		private string CheckWellFormedNess(XmlTextReader XmlReader)
		{
			//Get data
			XmlTextReader reader = XmlReader;

			//Initialize variables
			string strError = "";
			
			//Use try catch construction in case of errors
			try
			{								
				//Read file
				while (reader.Read())
				{
					//Do nothing
				}
				//When no error's strError is empty
							
			}
			
			catch (XmlException ex)
			{
				//Only the first error is reported
				strError += ex.Message.ToString() + "\r\n";							
			}
			catch (Exception excep)
			{
				//In case of other errors
				strError += excep.Message.ToString() + "\r\n";							
			}
			finally
			{
				if (reader.ReadState != ReadState.Closed)
				{
					reader.Close();
				}
			}
			
			//Construct message
			if (strError == "")
			{
				//No error has occured
				strError = "The document is Well-Formed.\r\nNo errors were found"; 
			}
			else
			{
				//Error's were found
				strError = "The document is not Well-Formed! The following error was found:\n\n" + strError;
			}
				
			return strError;

		}
	}
}
